﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AppointmentReminder_DB
{
    public partial class Form1 : Form
    {
        private const string CONNECTION_STRING = @"Provider=Microsoft.Jet.OLEDB.4.0; Data Source=..\..\Database\Appointments.mdb";
        private OleDbDataAdapter appointmentAdapter;
        private DataTable appointmentTable;

        public Form1()
        {
            InitializeComponent();

            Load += Form1_Load;
            btnSave.Click += BtnSave_Click;
        }

        private void BtnSave_Click(object sender, EventArgs e)
        {
            appointmentAdapter.Update(appointmentTable);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            LoadAppointmentTable();

            c1Schedule1.DataStorage.AppointmentStorage.Mappings.IdMapping.MappingName = "Id";
            c1Schedule1.DataStorage.AppointmentStorage.Mappings.Subject.MappingName = "Subject";
            c1Schedule1.DataStorage.AppointmentStorage.Mappings.Body.MappingName = "Body";
            c1Schedule1.DataStorage.AppointmentStorage.Mappings.Start.MappingName = "Start";
            c1Schedule1.DataStorage.AppointmentStorage.Mappings.End.MappingName = "End";
            c1Schedule1.DataStorage.AppointmentStorage.Mappings.Location.MappingName = "Location";
            c1Schedule1.DataStorage.AppointmentStorage.Mappings.AppointmentProperties.MappingName = "Properties";

            c1Schedule1.DataStorage.AppointmentStorage.DataSource = appointmentTable;
        }

        private void LoadAppointmentTable()
        {
            string query = "select * from Appointments";
            appointmentAdapter = new OleDbDataAdapter(query, CONNECTION_STRING);
            appointmentTable = new DataTable();
            appointmentAdapter.Fill(appointmentTable);

            OleDbCommandBuilder commandBuilder = new OleDbCommandBuilder(appointmentAdapter);
            commandBuilder.QuotePrefix = "[";
            commandBuilder.QuoteSuffix = "]";
        }
    }
}
